#include "cpu_conf.h"
#include "common.h"	
#include "tools.h"
#include "NRF.h"
//#include "nrf24l01.h"
#include "mirf.h"
#include "nRF24L01.h"

/*
#include "stm32f10x.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_gpio.h"
*/
unsigned char cont_int=0,sec=0,min=0,led_cnt=0,led_blnk=0;
unsigned char	step=0;
unsigned char k_menu=0,k_sel=0,k_time_out=0,k_mode=1;
unsigned int mag_val=100,fr_val=60;
unsigned int mag_tmp=1,fr_tmp=60,fr_val_tmp=60;
volatile unsigned int i_a=0,i_f=0;
unsigned char FM_mode=0,AM_mode=0;
unsigned int sleep_c=0;
volatile unsigned int i_snd=0,snd_time=0;
unsigned char modes=0;
unsigned char i_key=0,k_sleep=0;
unsigned char i_tmp=0;
unsigned char n_phase,n_phase_val=40;
unsigned int bat_val=0xffff;
unsigned char bat_is_low=0;
unsigned char	cont_det=0,cont_det_tmp=0, sleep_mode=0;
unsigned int T_phase_1,T_phase_2, T_phase_1_tmp,T_phase_2_tmp,T_phase_1_stor;
unsigned int reaction_1=0,threshold1_0=0,threshold2_0=0,T_phase_1_zero=0,T_phase_1_dose=0, dose_count=0;

unsigned char sec_val=0,speed=0,speed_tmp=0,DOSE=0,ZERO=0,dose_progress=0,dose_progress_tmp=0; 
			
unsigned char key_r_was_pressed=0,key_r_was_pressed_tmp=0;
unsigned char key_l_was_pressed=0,key_l_was_pressed_tmp=0;
unsigned char key_c_was_pressed=0,key_c_was_pressed_tmp=0;

unsigned char diagn_mode=0;

unsigned char i_rec=0;
unsigned char comand_val_uart1[10];
unsigned char	u1_tmp=0;
unsigned int sn_val=0,crc16=0;

unsigned char	nrf_rx_buf[32];
unsigned char	nrf_tx_buf[32];
unsigned char	buf[32];
unsigned char sta=0;

uint8_t tx_addr[5]={0x01,0x02,0x03,0x04,0x05};
//uint8_t rx_addr[5]={0x02,0x02,0x03,0x04,0x05};
uint8_t rx_addr[5]={0x02,0x02,0x03,0x04,0x05};


void menu_minus(unsigned char k_menu);
void menu_plus(unsigned char k_menu);

void AM_modulation (unsigned char AM_mode);
void FM_modulation (unsigned char FM_mode);

#define contact_n_phase	20
#define contact_t_phase	20
#define bat_val_min		7500

#define limit_snd_play	snd_time= play_snd (500, 1000);
#define inc_decr_snd_play	snd_time= play_snd (300, 15);

#define ver 0   

#define	start		0xaa
#define	adr_sn	0x0001

#define	mag			0xa1
#define	fr			0xa2
#define	am_m		0xa3
#define	fm_m		0xa4
#define	i_			0xa5

#define	suppl		0xa0



#define	sn_	0x0001
/*
#define	suppl_off			send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=suppl;	send_arr[4]=0xaa; send_arr[5]=0x55;
#define	mag_send(x)		send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=mag;		send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;
#define	fr_send(x)		send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=fr;		send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;
#define	amm_send(x)		send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=am_m;	send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;
#define	fmm_send(x)		send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=fm_m;	send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;
#define	int_send(x)		send_arr[0]=start;send_arr[1]=(0xff00&adr_sn)>>8;send_arr[2]=0x00ff&adr_sn;send_arr[3]=i_;		send_arr[4]=(0xff00&x)>>8; send_arr[5]=0x00ff&x;

#define	send_mes	tx_len=6;for(i_tmp=0;i_tmp<tx_len;i_tmp++){USART2_SendData(send_arr[i_tmp]);}
#define	send_crc	tx_len=6;for(i_tmp=0;i_tmp<tx_len;i_tmp++){crc16=crc16+send_arr[i_tmp];}USART2_SendData((0xff00&crc16)>>8);USART2_SendData(0x00ff&crc16);

*/

void USART2_IRQHandler(void) //   
{
  //     
  if((USART2->SR & USART_SR_RXNE)!=0) 
  {
    USART2->SR&=~USART_SR_RXNE; 
		
		u1_tmp=USART2->DR;
		//USART2_SendData(u1_tmp);
		
		if(u1_tmp==start){i_rec=0;}
		comand_val_uart1[i_rec]=u1_tmp;
		
		if (comand_val_uart1[0]==start)//    
		{
			sn_val=(comand_val_uart1[1]<<8)+(comand_val_uart1[2]);
			crc16=((comand_val_uart1[6]<<8)&0xff00)+(comand_val_uart1[7]);
			
			if(sn_val==sn_)
			{
				if (comand_val_uart1[3]==mag)	//   
				{
					if(((comand_val_uart1[4]<<8)+(comand_val_uart1[5]))<=500){mag_val=(comand_val_uart1[4]<<8)+(comand_val_uart1[5]);}
					//mag_val=(comand_val_uart1[4]<<8)+(comand_val_uart1[5]);
				}
				if (comand_val_uart1[3]==fr)	//   
				{
					if(((comand_val_uart1[4]<<8)+(comand_val_uart1[5]))<=350){fr_val_tmp=(comand_val_uart1[4]<<8)+(comand_val_uart1[5]);if(fr_val_tmp<15){fr_val=fr_val_tmp=16;}else{fr_val=fr_val_tmp;}}
				//	fr_val=(comand_val_uart1[4]<<8)+(comand_val_uart1[5]);
				}
				if (comand_val_uart1[3]==am_m)	//   AM
				{
					if(comand_val_uart1[5]<4){AM_mode=comand_val_uart1[5];}
				//	USART2_SendData(AM_mode);
				}
				if (comand_val_uart1[3]==fm_m)	//   FM
				{
					if(comand_val_uart1[5]<3){FM_mode=comand_val_uart1[5];}
				//	USART2_SendData(FM_mode);
						
				}
				if (comand_val_uart1[3]==suppl)
				{
					PWM_halt;capt_halt;
					snd_time= play_snd (500, 200);delay(10000);
					snd_time= play_snd (500, 200);delay(10000);
					snd_time= play_snd (500, 200);	
					/*
					LED_x_ind_nfill(0);LED_y_ind_nfill(0);
					delay(7000);LED_y_ind_nfill(1);
					delay(7000);LED_y_ind_nfill(2);
					delay(7000);LED_y_ind_nfill(3);
					delay(7000);LED_y_ind_nfill(4);
					delay(7000);LED_y_ind_nfill(5);
					delay(7000);LED_y_ind_nfill(0);
					delay(7000);LED_x_ind_nfill(5);
					delay(7000);LED_x_ind_nfill(4);
					delay(7000);LED_x_ind_nfill(3);
					delay(7000);LED_x_ind_nfill(2);
					delay(7000);LED_x_ind_nfill(1);
					delay(7000);LED_x_ind_nfill(0);
					*/
					LV_off;HV_OFF;
					power_save_mode ();
				}
			}
		}
		
		i_rec++;if(i_rec>6){i_rec=0;sn_val=0;}
		
		//USART2->SR&=~USART_SR_RXNE; 
		
  } 
	return;
}

void TIM4_IRQHandler() 
{	
	TIM4->SR &= ~TIM_SR_UIF;
	i_snd++;
	if(i_snd> snd_time)
	{		
		i_snd=0;
		TIM4->DIER &= ~TIM_DIER_UIE;
		TIM4->CR1 &= ~TIM_CR1_CEN;TIM4->CNT=0;
	}
	
	return;
}
void TIM1_UP_TIM16_IRQHandler()
{
	TIM1->SR &= ~TIM_SR_UIF;	
	capt_halt;	PWM_halt;
	
	n_phase_val=n_phase*2;
	n_phase=0;
	
	set_pmp_t(mag_tmp);set_pmp_f(fr_tmp);
	
	capt_start;PWM_start;
	//GPIOA->BSRR|=  GPIO_BSRR_BS5;GPIOA->BSRR|=  GPIO_BSRR_BR5;
	return;
}

void TIM2_IRQHandler (void) // capture
{ 
	TIM2->SR &= ~TIM_SR_CC1IF;
	TIM2->SR &= ~TIM_SR_CC2IF;
	
	n_phase++;
	//if (n_phase==1){TIM2->DIER|= TIM_DIER_CC2IE;TIM2->DIER|= TIM_DIER_CC1IE;GPIOA->BSRR|=GPIO_BSRR_BS5;GPIOA->BSRR|=GPIO_BSRR_BR5; }	
	//if (n_phase==1){GPIOA->BSRR|=GPIO_BSRR_BS5;GPIOA->BSRR|=  GPIO_BSRR_BR5;if(n_phase_val<=2){T_phase_1=TIM2->CCR2-TIM2->CCR1;T_phase_2=TIM2->CCR2-TIM2->CCR1;}}
//	if (n_phase==2){T_phase_1=TIM2->CCR1;T_phase_2=TIM2->CCR1;GPIOA->BSRR|=GPIO_BSRR_BS5;GPIOA->BSRR|=  GPIO_BSRR_BR5;	}			
	
	if (n_phase==1){if(n_phase_val<=2){T_phase_1=TIM2->CCR2-TIM2->CCR1;T_phase_2=TIM2->CCR2-TIM2->CCR1;}}
	if (n_phase==2){T_phase_1=TIM2->CCR1;T_phase_2=TIM2->CCR1;}		


	return;
}
void SysTick_Handler()// 50  
{
	SysTick->CTRL&=~SysTick_CTRL_COUNTFLAG;
	
	FM_modulation (FM_mode);
	AM_modulation (AM_mode);
	

	
	if (diagn_mode==1)
	{
			
		led_cnt++;
		if(led_cnt>4)
		{
			led_cnt=0;
			
			led_blnk++; 
			if (led_blnk<=5){LED_x_ind_nfill(led_blnk+1);}
			if (led_blnk> 5){LED_x_ind_nfill((10-led_blnk)+1);}	
			
			if (led_blnk>10){led_blnk=0;}
			
			
			LED_x_ind_or(k_mode);
		}
		
	}
	
	/*
	if (diagn_mode==1)
	{
		led_cnt++;
		if (led_cnt==5){LED_x_ind_or(k_mode);}
		if(led_cnt>10)
		{
			led_cnt=0;
			LED_x_ind_nfill(0);
		}
	}
	*/
	
	return;
}


int main (void)
{

	pll_init ();
	
	pio_config ();
	sys_tick_config ();
	adc_init ();
	T4_config ();

	RTC_conf ();
	
	LV_on;HV_ON;


	if((PWR->CSR&PWR_CSR_SBF)==0){ goto strt;} //      

	//   

	
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}
	if(keyA(center_key)==1){delay(7000);}
	else {LV_off;power_save_mode ();}


	strt:
	
	snd_time= play_snd (500, 200);
	delay(3000);delay(3000);delay(3000);delay(1000);
	snd_time= play_snd (500, 200);
	delay(3000);delay(3000);delay(3000);delay(1000);
	snd_time= play_snd (500, 200);
	delay(3000);delay(3000);delay(3000);delay(1000);
	snd_time= play_snd (500, 200);
	delay(3000);delay(3000);delay(3000);delay(1000);
	
	

	
	T1_config();	
	mag_val=10;
	
	k_mode=2;
	FM_mode=0;
	AM_mode=0;
	fr_val=50;
	diagn_mode=0;
	
	set_pmp_t(mag_val);set_pmp_f(fr_val);
	
	
	//led_mag_ind(mag_val);
	
	T2_capt_init();capt_halt;	
	capt_start;
	
	USART1_Init();
//	USART2_Init();


/*
	mirf_init();


  _delay_ms(2);

  //mirf_config();


	mirf_config_register(CONFIG, (1 << EN_CRC) | (1 << CRCO) | (1 << PRIM_RX)| (1 << PWR_UP));
	mirf_config_register(EN_RXADDR, (1 << ERX_P0));
	mirf_config_register(SETUP_AW, SETUP_AW_5BYTES_ADDRESS);
	mirf_config_register(SETUP_RETR, SETUP_RETR_DELAY_250MKS | SETUP_RETR_UP_TO_2_RETRANSMIT);
	mirf_config_register(RF_CH,1);
	mirf_config_register(RF_SETUP, RF_SETUP_1MBPS | RF_SETUP_0DBM);
	mirf_config_register(RX_PW_P0,5);
	mirf_set_RADDR(rx_addr);
	mirf_set_TADDR(rx_addr);
	
	USART1_SendData(radio_readreg(CONFIG));
	USART1_SendData(radio_readreg(EN_RXADDR));
	USART1_SendData(radio_readreg(SETUP_AW));
	USART1_SendData(radio_readreg(SETUP_RETR));
	USART1_SendData(radio_readreg(RF_CH));
	USART1_SendData(radio_readreg(RF_SETUP));
	USART1_SendData(radio_readreg(RX_PW_P0));
	radio_readreg_buf(RX_ADDR_P0,  buf, 5); 
	USART1_SendData(buf[0]);
	USART1_SendData(buf[1]);
	USART1_SendData(buf[2]);
	USART1_SendData(buf[3]);
	USART1_SendData(buf[4]);
	
	mirf_config_register(CONFIG, (1 << EN_CRC) | (1 << CRCO) | (1 << PRIM_RX)| (1 << PWR_UP));
	USART1_SendData(radio_readreg(CONFIG));
*/



	radio_init();
  while (!radio_start()) { _delay_ms(1000);}

// reg val indication
	USART1_SendData(radio_readreg(CONFIG));
	USART1_SendData(radio_readreg(EN_RXADDR));
	USART1_SendData(radio_readreg(SETUP_AW));
	USART1_SendData(radio_readreg(SETUP_RETR));
	USART1_SendData(radio_readreg(RF_CH));
	USART1_SendData(radio_readreg(RF_SETUP));
	USART1_SendData(radio_readreg(RX_PW_P0));
	radio_readreg_buf(RX_ADDR_P0,  buf, 5); 
	USART1_SendData(buf[0]);
	USART1_SendData(buf[1]);
	USART1_SendData(buf[2]);
	USART1_SendData(buf[3]);
	USART1_SendData(buf[4]);

_delay_ms(10);

//	mirf_send(nrf_tx_buf,4);

//  radio_assert_ce();		
//	csn_assert();
	//radio_assert_ce(); 



	while (1)
	{
//mirf_data_ready();
/*
		mirf_get_data(buf);
USART1_SendData(buf[0]);
USART1_SendData(buf[1]);
USART1_SendData(buf[2]);
USART1_SendData(buf[3]);
*/




//mirf_send(buf, 4);

//USART1_SendData(radio_readreg(STATUS));

//_delay_ms(10);

//USART1_SendData(radio_readreg(RF_CH));

//mirf_config();
/*
 if(!mirf_data_ready())
	{
		sta=mirf_data_ready();	
		mirf_get_data(buf);
USART1_SendData(buf[0]);
USART1_SendData(buf[1]);
USART1_SendData(buf[2]);
USART1_SendData(buf[3]);
}
*/


/*
nrf_tx_buf[0]++;
nrf_tx_buf[1]--;
nrf_tx_buf[2]++;
nrf_tx_buf[3]--;
nrf_tx_buf[4]++;
nrf_tx_buf[5]--;
nrf_tx_buf[6]++;
nrf_tx_buf[7]--;
*/


//_delay_ms(100);

//USART1_SendData(radio_readreg(sta));
//check_radio();

//USART1_SendData(radio_readreg(CONFIG));



//radio_read_buf(R_RX_PAYLOAD, buf, 5);

//USART1_SendData(buf[0]);
//USART1_SendData(buf[1]);
//USART1_SendData(buf[2]);
//USART1_SendData(buf[3]);


//USART1_SendData(radio_read_buf(R_RX_PAYLOAD, nrf_rx_buf, 3));

//-------------------------------------------------------	/
		
		
		if(keyA(center_key)==1)
		{
			key_c_was_pressed_tmp=1;
			k_time_out=0;	
			k_sleep=0;	
			
				sleep_c++;

				if (sleep_c>80)
				{
					sleep_c=0;
					sleep_mode=1;
					
					PWM_halt;capt_halt;
					snd_time= play_snd (500, 200);delay(10000);
					snd_time= play_snd (500, 200);delay(10000);
					snd_time= play_snd (500, 200);	
					
					delay(7000);delay(7000);delay(7000);delay(7000);delay(7000);
					delay(7000);delay(7000);delay(7000);delay(7000);delay(7000);
					delay(7000);delay(7000);delay(7000);delay(7000);delay(7000);
					HV_OFF;
					LV_off;
					power_save_mode ();
				}
				delay(3000);
		}
		
		
		if(keyA(center_key)==0)//
		{	
			key_c_was_pressed=0;
			sleep_c=0;
			
			
			if (key_c_was_pressed_tmp!=key_c_was_pressed)
			{
				key_c_was_pressed=key_c_was_pressed_tmp;	
			/*
				delay(3000);
				k_time_out=0;
				k_mode++;
				if(k_mode>5){k_mode=1;}
				LED_x_ind_nfill(k_mode);
		
				if (k_mode==1)
				{
					FM_mode=0;
					AM_mode=0;
					fr_val=16;
					//diagn_mode=0;
					led_mag_ind(mag_val);
				}
				if (k_mode==2)
				{
					FM_mode=0;
					AM_mode=0;
					fr_val=50;	
					//diagn_mode=0;
					led_mag_ind(mag_val);
				}
				if (k_mode==3)
				{
					FM_mode=0;
					AM_mode=0;
					fr_val=150;
					//diagn_mode=0;
					led_mag_ind(mag_val);
				}
				if (k_mode==4)
				{
					FM_mode=0;
					fr_val=50;
					AM_mode=3;
					//diagn_mode=0;
					led_mag_ind(mag_val);
				}	
				if (k_mode==5)
				{
					FM_mode=1;
					AM_mode=0;
					//diagn_mode=0;
					led_mag_ind(mag_val);
				}	
				snd_time= play_snd (500, 100);	
				*/
			}
			
			key_c_was_pressed_tmp=0;
		}	
		
		if (keyA(center_key)==1)
		{
			key_c_was_pressed=0;
		}
		
		/*
//-------------------------------------------------------		

		if(keyA(right_key)==0)
		{
			key_r_was_pressed_tmp=1;
			k_time_out=0;
			k_sleep=0;
			if (i_key<=8)i_key++;
			else
			{
				step=0;
				menu_plus(k_menu);

			}
			delay(3000);
		}
		if(keyA(right_key)==1)//
		{	
			key_r_was_pressed=0;
			if (key_r_was_pressed_tmp!=key_r_was_pressed)
			{
				key_r_was_pressed=key_r_was_pressed_tmp;
				k_time_out=0;
				step=1;
				menu_plus(k_menu);

			}
			key_r_was_pressed_tmp=0;
		}
//-------------------------------------------------------		
		

		if(keyA(left_key)==0)
		{
			key_l_was_pressed_tmp=1;
			k_time_out=0;
			k_sleep=0;
			if (i_key<=8)i_key++;
			else
			{
				step=0;
				menu_minus(k_menu);
			}
			delay(3000);
		}
		if(keyA(left_key)==1)//
		{	
			key_l_was_pressed=0;
			
			if (key_l_was_pressed_tmp!=key_l_was_pressed)
			{
				key_l_was_pressed=key_l_was_pressed_tmp;
				k_time_out=0;
				step=1;
				menu_minus(k_menu);

			}
			key_l_was_pressed_tmp=0;
		}
		
		#if	(ver==1)
		if((keyA(right_key)==0)&&(keyA(left_key)==0))
		{
			diagn_mode++;
			k_time_out=0;
			if (diagn_mode>1){diagn_mode=0;}
			if(diagn_mode==0)
			{
				snd_time= play_snd (200, 500);	delay(20000);	
				LED_x_ind_nfill(k_mode);
			}
			if(diagn_mode==1)
			{
				snd_time= play_snd (200, 500);	delay(20000);
				snd_time= play_snd (300, 500);	delay(20000);	
				LED_y_ind_nfill(0);
			}
		}	
		#endif		
		
		
		if ((keyA(center_key)==1)&(keyA(right_key)==0)&(keyA(left_key)==0))
		{
			key_r_was_pressed=0;
			key_l_was_pressed=0;
			key_c_was_pressed=0;
		}
		if ((keyA(right_key)==1)&(keyA(left_key)==1))
		{
			i_key=0;
		}
*/

		//if (((n_phase_val<=contact_n_phase)&(T_phase_1>=contact_t_phase))|(n_phase_val<=2))	{cont_det_tmp=1;k_sleep=0;}
		if ((T_phase_1>=contact_t_phase)|(n_phase_val<=2))	{cont_det_tmp=1;k_sleep=0;}
		if (T_phase_1<contact_t_phase-2){cont_det_tmp=0;}	
		//else	{cont_det_tmp=0;}		
		
		
		if (cont_det_tmp!=cont_det)
		{
			cont_det=cont_det_tmp;
			if (cont_det==1)
			{
				sec=0; min=0;speed_tmp=speed=99;	
				RTC_refr_par ();
				
			#if	(ver==1)
				snd_time= play_snd (500, 100);
			#endif		
			}
			
			if (cont_det==0)//  
			{
				sec_val=0;DOSE=0;ZERO=0;
				threshold1_0=T_phase_1+10;threshold2_0=T_phase_2+10;	
			//	LED_y_ind_nfill(0);
			}
	}

	if((RTC->CRL&RTC_CRL_SECF)==RTC_CRL_SECF)
	{	
		RTC->CRL&= ~RTC_CRL_SECF;
			
		sec++;if (sec>60){sec=0;min++;}
		
	//	USART2_SendData(0xca);
	
//		UART1_send_val(T_phase_1);
//		UART1_send_val(T_phase_2);
//		UART1_send_val(n_phase_val);
 	
		if ((diagn_mode==0)|((diagn_mode==1)&(cont_det==0)))
		{
			k_time_out++;
			if (k_time_out>2) //       2
			{
				//LED_y_ind_nfill(0);
					//if(k_menu!=0)	LED_x_ind_nfill(0);
			}
		}
		 
		if (cont_det==1)
		{
			sec_val++;
			#if	(ver==1)
			if((sec_val>30)&(sec_val%60==30)){snd_time= play_snd (500, 200);}
			if((sec_val>30)&(sec_val%60==0)){	snd_time= play_snd (500, 200);delay(18000);snd_time= play_snd (500, 200);}				
			#endif		

				
			if ((diagn_mode==1)&(DOSE==0))
			{
				if (sec_val==1)
				{
					reaction_1=T_phase_1;	// .
					threshold1_0=(T_phase_1*19)/10;
					//threshold2_0=(T_phase_2*19)/10;
					dose_count=((threshold1_0-reaction_1)/5);
					led_react_ind(reaction_1);delay(40000);LED_y_ind_nfill(0);
				}
				if (sec_val>1)
				{			
					//  
					if((T_phase_1>=reaction_1+1*dose_count)&(T_phase_1<reaction_1+2*dose_count)){dose_progress_tmp=1;}
					if((T_phase_1>=reaction_1+2*dose_count)&(T_phase_1<reaction_1+3*dose_count)){dose_progress_tmp=2;}
					if((T_phase_1>=reaction_1+3*dose_count)&(T_phase_1<reaction_1+4*dose_count)){dose_progress_tmp=3;}
					if((T_phase_1>=reaction_1+4*dose_count)&(T_phase_1<reaction_1+5*dose_count)){dose_progress_tmp=4;}
					if((T_phase_1>=reaction_1+5*dose_count)){dose_progress_tmp=5;}
					
					if (dose_progress_tmp!=dose_progress)
					{
						dose_progress=dose_progress_tmp;
						led_speed_ind(dose_progress);
						snd_time= play_snd (700, 100);delay(10000);
					}
/*
					if (speed!=0) {speed_tmp=(abs(T_phase_1-reaction_1))*128/sec_val/reaction_1;}
					if (speed_tmp!=speed)
					{		
						speed=speed_tmp;	
						//led_speed_ind(speed); //  	

						if(speed==0)
						{
							T_phase_1_zero=T_phase_1;
							ZERO=1;
							LED_y_ind_pair(0);delay(9000);
							LED_y_ind_pair(1);delay(9000);
							LED_y_ind_pair(2);delay(9000);
							LED_y_ind_pair(3);delay(9000);
							
							LED_y_ind_pair(0);delay(9000);
							LED_y_ind_pair(3);delay(9000);
							LED_y_ind_pair(0);delay(9000);
							LED_y_ind_pair(3);delay(9000);
							LED_y_ind_pair(0);delay(9000);
							
							snd_time= play_snd (500, 200);delay(30000);
							snd_time= play_snd (500, 200);delay(15000);
							snd_time= play_snd (500, 200);delay(30000);	
							snd_time= play_snd (500, 200);delay(15000);
							snd_time= play_snd (500, 200);	
						}
						
						if(speed==1)
						{
							snd_time= play_snd (300, 500);	delay(20000);
						}
						if(speed==2)
						{
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
						}
						if(speed==3)
						{
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
						}
						if(speed==4)
						{
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
						}
						if(speed==5)
						{
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
							snd_time= play_snd (300, 500);	delay(20000);
						}
					}
					*/
						//	dose sound
						//if ((T_phase_1>=threshold1_0)|(T_phase_2>=threshold2_0))
						if((T_phase_1>=reaction_1+5*dose_count))
						{
							T_phase_1_dose=T_phase_1;							
							DOSE=1; 
							snd_time= play_snd (500, 200);delay(10000);
							snd_time= play_snd (500, 200);delay(5000);
							snd_time= play_snd (500, 200);delay(10000);
							snd_time= play_snd (500, 200);delay(5000);
							snd_time= play_snd (500, 200);delay(10000);
							snd_time= play_snd (500, 200);
							
							
							LED_y_ind_nfill(0);delay(3000);
							LED_y_ind_nfill(1);delay(3000);
							LED_y_ind_nfill(2);delay(3000);
							LED_y_ind_nfill(3);delay(3000);
							LED_y_ind_nfill(4);delay(3000);
							LED_y_ind_nfill(5);delay(3000);
							LED_y_ind_nfill(4);delay(3000);
							LED_y_ind_nfill(3);delay(3000);
							LED_y_ind_nfill(2);delay(3000);
							LED_y_ind_nfill(1);delay(3000);
							LED_y_ind_nfill(0);delay(3000);

						}
						
					if (((sec_val>10)&&((sec_val-10)%7==0))||(sec_val==10))	
					{
						threshold1_0=(threshold1_0+T_phase_1)/2;
						//threshold2_0=(threshold2_0+T_phase_2)/2;  
						dose_count=(threshold1_0-reaction_1)/5;
					}
				}
			}
		}	
		ADC1->CR2 |= ADC_CR2_JSWSTART;if((ADC1->SR & ADC_SR_JEOC) == ADC_SR_JEOC)	{	bat_val=10*(((ADC1->JDR1*volt_33)/4096));}
		if (sec%4==3)
		{
			if (bat_val<7000)bat_is_low=1;
			if (bat_val>=7500) bat_is_low=0;
		}
		if ((bat_is_low==1)&(cont_det==0)){snd_time= play_snd (500, 20);}
		/*
		if(cont_det==0)
		{
			k_sleep++;
			if (k_sleep>60)
			{
				k_sleep=0;
				sleep_c=0;
				sleep_mode=1;
				PWM_halt;capt_halt;	

				snd_time= play_snd (500, 200);delay(10000);
				snd_time= play_snd (500, 200);delay(10000);
				snd_time= play_snd (500, 200);					
					
				LED_x_ind_nfill(0);LED_y_ind_nfill(0);
				delay(7000);LED_y_ind_nfill(1);
				delay(7000);LED_y_ind_nfill(2);
				delay(7000);LED_y_ind_nfill(3);
				delay(7000);LED_y_ind_nfill(4);
				delay(7000);LED_y_ind_nfill(5);
				delay(7000);LED_y_ind_nfill(0);
				delay(7000);LED_x_ind_nfill(5);
				delay(7000);LED_x_ind_nfill(4);
				delay(7000);LED_x_ind_nfill(3);
				delay(7000);LED_x_ind_nfill(2);
				delay(7000);LED_x_ind_nfill(1);
				delay(7000);LED_x_ind_nfill(0);
				delay(30000);
				LV_off;
				power_save_mode ();
			}
		}
		*/
	}	
	}
}
void menu_plus(unsigned char k_menu)
{
	if (k_menu==0) //  
	{
		if(step==0)
		{
			if	(mag_val>64) {mag_val=mag_val+mag_val/64;}
			else {mag_val++;}
		}
		if(step==1){mag_val++;}
			
			if (mag_val>500) {mag_val=500;limit_snd_play;}
			else {inc_decr_snd_play;}
			led_mag_ind(mag_val);	
	}
	if (k_menu==1)
	{

	}
	if (k_menu==2)
	{

	}
	if (k_menu==3) //  
	{
		delay(3000);
		AM_mode++;
		if(AM_mode>6) {AM_mode=6;snd_time= play_snd (500, 1000);}
		else {snd_time= play_snd (500, 10);}
		LED_y_ind_fill(AM_mode);
	}
	if (k_menu==4)//  
	{
		delay(3000);
		FM_mode++;
		if(FM_mode>4) {FM_mode=4;snd_time= play_snd (500, 1000);}
		else {snd_time= play_snd (500, 10);}
		LED_x_ind_fill(FM_mode);	
	}
	if (k_menu==5)//   
	{
			if	(fr_val>63) {fr_val=fr_val+fr_val/64;}
			else {fr_val++;}
			if (fr_val>320) {fr_val=320;snd_time= play_snd (500, 600);}
			else {snd_time= play_snd (500, 10);}
			led_fr_ind(fr_val);
			
	}
	return;
}
void menu_minus(unsigned char k_menu)
{
	if (k_menu==0) //  
	{
		if	(mag_val>64) {mag_val=mag_val-mag_val/64;}
		else {mag_val--;}
		if (mag_val<1) {mag_val=1;limit_snd_play;}
		else {inc_decr_snd_play;}
		led_mag_ind(mag_val);
	}
	if (k_menu==1)// F1
	{
		delay(3000);
		fr_val=60;
	}
	if (k_menu==2) // F2
	{
		delay(3000);
		fr_val=90;
	}
	if (k_menu==3)//  
	{
		delay(3000);
		FM_mode--;
		if(FM_mode>4) {FM_mode=0;snd_time= play_snd (500, 1000);}
		else {snd_time= play_snd (500, 10);}
		LED_x_ind_fill(FM_mode);	
	}
	if (k_menu==4)//   
	{

	}
	if (k_menu==5)//   
	{
			if	(fr_val>63) {fr_val=fr_val-fr_val/64;}
			else {fr_val--;}
			if (fr_val<15) {fr_val=15;snd_time= play_snd (500, 1000);}
			else {snd_time= play_snd (500, 10);}
			led_fr_ind(fr_val);
	}
	return;
}

void AM_modulation (unsigned char AM_mode)
{
	if (AM_mode==0)
	{
	 mag_tmp=mag_val;

	}
	if (AM_mode==1)		// 1:1
	{							
		i_a++;
		if (i_a<=4)   						mag_tmp= i_a*(mag_val/4)+1;
		if ((i_a>4)&(i_a<=46)) 		mag_tmp= mag_val;
		if ((i_a>46)&(i_a<=50))		mag_tmp= ((mag_val/4)*(50-i_a))+10;
		if ((i_a>50)&(i_a<100))		mag_tmp= 1;
		if (i_a>=100)	i_a=0;
	}					 
	if (AM_mode==2)	  //1:2
	{
		i_a++;
		if (i_a<=4)   							mag_tmp= i_a*(mag_val/4);
		if ((i_a>4)&(i_a<=96)) 			mag_tmp= mag_val;
		if ((i_a>96)&(i_a<=100))		mag_tmp= ((mag_val/4)*(100-i_a))+10;
		if ((i_a>100)&(i_a<150))		mag_tmp= 1;
		if (i_a>=150)	i_a=0;
	}
  	if (AM_mode==3)		 //1:3
	{
		i_a++;
		if (i_a<=4)   							mag_tmp= i_a*(mag_val/4);
		if ((i_a>4)&(i_a<=146)) 		mag_tmp= mag_val;
		if ((i_a>146)&(i_a<=150))		mag_tmp= ((mag_val/4)*(150-i_a))+10;
		if ((i_a>150)&(i_a<200))		mag_tmp= 1;
		if (i_a>=200)	i_a=0;
	}
	/*
	if (AM_mode==4)		 //1:4
	{
		i_a++;
		if (i_a<=4)   							mag_tmp= i_a*(mag_val/4);
		if ((i_a>4)&(i_a<=196)) 		mag_tmp= mag_val;
		if ((i_a>196)&(i_a<=200))		mag_tmp= ((mag_val/4)*(200-i_a))+10;
		if ((i_a>200)&(i_a<250))		mag_tmp=10;

		if (i_a>=250)	i_a=0;
	}
	if (AM_mode==5)		//1:5
	{
		i_a++;
		if (i_a<=4)   							mag_tmp= i_a*(mag_val/4);
		if ((i_a>4)&(i_a<=246)) 		mag_tmp= mag_val;
		if ((i_a>246)&(i_a<=250))		mag_tmp= ((mag_val/4)*(250-i_a))+10;
		if ((i_a>250)&(i_a<300))		mag_tmp= 10;
		if (i_a>=300)	i_a=0;
	}
	if (AM_mode==6)		// 1:6
	{					 
		i_a++;
		if (i_a<=4)   							mag_tmp= i_a*(mag_val/4);
		if ((i_a>4)&(i_a<=296)) 		mag_tmp= mag_val;
		if ((i_a>296)&(i_a<=300))		mag_tmp= ((mag_val/4)*(300-i_a))+10;
		if ((i_a>300)&(i_a<350))		mag_tmp= 10;
		if (i_a>=350)	i_a=0;

	}
	*/
	if (AM_mode==4)	 // AMV
	{
		i_a++;
		// AM1
		if (i_a<=4)   							mag_tmp= i_a*(mag_val/4);
		if ((i_a>4)&(i_a<=46)) 			mag_tmp= mag_val;
		if ((i_a>46)&(i_a<=50))			mag_tmp= ((mag_val/4)*(50-i_a))+5;
		if ((i_a>50)&(i_a<100))			mag_tmp= 1;
		//AM2
		if ((i_a>=100)&(i_a<=104))  mag_tmp= (i_a-100)*(mag_val/4);
		if ((i_a>104)&(i_a<=196)) 	mag_tmp= mag_val;
		if ((i_a>196)&(i_a<=200))		mag_tmp= ((mag_val/4)*(200-i_a))+5;
		if ((i_a>200)&(i_a<250))		mag_tmp= 1;
		//AM3
		if ((i_a>=250)&(i_a<254))  	mag_tmp= (i_a-250)*(mag_val/4);
		if ((i_a>254)&(i_a<=396)) 	mag_tmp= mag_val;
		if ((i_a>396)&(i_a<=400))		mag_tmp= ((mag_val/4)*(400-i_a))+5;
		if ((i_a>400)&(i_a<450))		mag_tmp= 1;
		//AM4
		if ((i_a>=450)&(i_a<=454))  mag_tmp= (i_a-450)*(mag_val/4);
		if ((i_a>454)&(i_a<=646)) 	mag_tmp= mag_val;
		if ((i_a>646)&(i_a<=650))		mag_tmp= ((mag_val/4)*(650-i_a))+10;
		if ((i_a>650)&(i_a<700))		mag_tmp=1;
		//AM5
		if ((i_a>=700)&(i_a<=704))  mag_tmp= (i_a-700)*(mag_val/4);
		if ((i_a>704)&(i_a<=946)) 	mag_tmp= mag_val;
		if ((i_a>946)&(i_a<=950))		mag_tmp= ((mag_val/4)*(950-i_a))+10;
		if ((i_a>950)&(i_a<1000))		mag_tmp= 1;
		//AM6
		if ((i_a>=1000)&(i_a<=1004))  mag_tmp= (i_a-1000)*(mag_val/4);
		if ((i_a>1004)&(i_a<=1296)) 	mag_tmp= mag_val;
		if ((i_a>1296)&(i_a<=1300))		mag_tmp= ((mag_val/4)*(1300-i_a))+10;
		if ((i_a>1300)&(i_a<1350))		mag_tmp= 1;
		if (i_a>=1350)	i_a=0;
	}

	return;
}

void FM_modulation (unsigned char FM_mode)
{
	if (FM_mode==0)
	{	  
		fr_tmp=fr_val; //  
	}
	/*
	if (FM_mode==1)	// FM1	   30 - 120 
	{
		i_f++;
		if (i_f<=175) {if (i_f%2==0)	{fr_tmp=((10*i_f)/19)+30;}} 
		if ((i_f>175)& (i_f<=350)){if (i_f%2==0)	{fr_tmp=(10*(350-i_f)/19)+30;}}
		if (i_f>350){i_f=0;fr_tmp=15;} 
	}
	*/
		if (FM_mode==1)	// FM1	   15 - 150 
	{
		i_f++;
		if (i_f<=175) {if (i_f%2==0)	{fr_tmp=((77*i_f)/100)+15;}} 
		if ((i_f>175)& (i_f<=350)){if (i_f%2==0)	{fr_tmp=(77*(350-i_f)/100)+15;}}
		if (i_f>350){i_f=0;fr_tmp=15;} 
	}
	if (FM_mode==2)	// ??2	 ?? 60 ?? ?? 250 ??
	{
		i_f++;

		if (i_f<=175)		// ?? 60?? ??? ??????? ?? 
		{
		 	if (10*i_f%5==0)	fr_tmp=(i_f)+60;
		}

		if ((i_f>175)& (i_f<=350))
		{	
			if (10*i_f%5==0)	fr_tmp=((350-i_f))+60;			
		}
		if (i_f>350)
		{
		   	i_f=0;
			fr_tmp=60;
		}	
	}
	if (FM_mode==3)	// ??3	 ?? 100 ?? ?? 420 ??
	{
		i_f++;

		if (i_f<=175)		// ?? 100?? ??? ??????? ?? 
		{
		 	if (10*i_f%5==0)	fr_tmp=((100*i_f)/55)+100;
		}

		if ((i_f>175)& (i_f<=350))
		{	
			if (10*i_f%5==0)	fr_tmp=((100*(350-i_f))/55)+100;			
		}
		if (i_f>350)
		{
		   	i_f=0;
			fr_tmp=100;
		}	
	}
	if (FM_mode==4)	// ??X	 ?? 10 ?? ?? 420 ??
	{
		i_f++;

		if (i_f<=175)		// ?? 10?? ??? ??????? ?? 
		{
		 	if (10*i_f%5==0)	fr_tmp=((100*i_f)/43)+15;
		}

		if ((i_f>175)& (i_f<=350))
		{	
			if (10*i_f%5==0)	fr_tmp=((100*(350-i_f))/43)+15;			
		}
		if (i_f>350)
		{
		   	i_f=0;
			fr_tmp=15;
		}	
	}
/*
	if (FM_mode==5)
	{
	   i_f++;
	   if (i_f>10)	
	   {
	   		i_f=0;
			fr_tmp=(0x1FF&rand())+16;
	   }
	}
	*/
	return;
}




